MNTDIR="$1"
TMP=$MNTDIR/userland_tmp
UPDATEDIR=var/lib/node-eye/update
UPDATEHOOK=var/lib/node-eye/update-hook.sh
USERLAND=$(find $MNTDIR/$UPDATEDIR | grep .tar.gz | head -1)
if [ "$USERLAND" ]; then
  find $MNTDIR -depth -path "*$UPDATEDIR*" -prune -o -print | sed -e 's/ /\\ /g' | xargs rm -f
  find $MNTDIR -depth -type d | xargs rmdir

  mkdir -p $TMP
  tar -zxf $USERLAND -C $MNTDIR
  ret=$?

  if [ $ret -eq 0 ]; then
    rm -f $TMP/$UPDATEHOOK
    # To reduce the file size of eMMC
    mv $TMP/* $MNTDIR
    # mv can't move var directory
    cp -r $TMP/* $MNTDIR
  fi
  rm -rf $TMP
  rm -f $USERLAND
  sync

  if [ $ret -ne 0 ]; then
    /bin/reboot
  fi
fi
